/*	junoproc 1.6	junopine 1.6

	juno inbox to a unix mua using procmail

	junoproc [procmailrc] <juno_inbox
	
	or not, if you prefer:
	
	topine <juno_inbox >pine_inbox

	use date at start of run for juno internal messages.
	
	This program uses seek on its input file.  It will lose pieces of
	headers if you run it on a pipe.
	
	GPL <whitnl73@juno.com> 1999 */
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#define FOLD 0
/* make the From_ header pleasing to mutt as well as to pine, which is */
/* not so fussy  */
/* mutt doesn't want _anything_ but From foo@bar.stool.net <date> */
/* so if we see < and > we keep what's within discarding all other */
/* and if we see ( and ) they enclose comments and have to go */
int mutt(int el, char *frum)
{
    char *less, *more;
    int ent;
    if (less = strchr(frum, 60)) {	/* < */
	if (more = strchr(less, 62)) {	/* > */
	    strncpy(frum + 5, less + 1, more - less - 1);
	    ent = more - less + 4;
	    return ent;
	}
    }
    if (less = strchr(frum, 40)) {
	if (more = strchr(less, 41)) {
	    ent = less - frum - 1;
	    return ent;
	}
    }
    return el;
}
int main(int argc, char *argv[])
{
    char be[1024], good[1024];
    void *a, *b, *c, *bee, *sea;
    FILE *splat = NULL;
    long skipt;
    time_t o_go;
    time_t o_lose;
    char didi[64];
    char *brk, *nb;
    size_t l, m;
    off_t hepigs = 0;
    int why, num, off, fold = 0, spam = 0, header, proc = 1, rabid;
    char day[7], mon[3], was, tie[11], tizzy[7];
    char procm[256] = "procmail";
    o_lose = time(NULL);
    if (argv[0][strlen(argv[0]) - 1] == 101)
	proc = 0;		/* topine */
    if (argc > 1) {
	strcat(procm, " -m ");
	strcat(procm, argv[1]);
    }
    for (;;) {
	if (!(fgets(be, 1024, stdin)))
	    break;
	header = 0;
	l = strlen(be);
	skipt += l;
	if (l > 1023)
	    fprintf(stderr, "%d\n%s\n%d\n", l, be, ftell(stdin));
	if (be[l - 1] == 10)
	    l -= 1;
	if (be[l - 1] == 13)
	    l -= 1;
	if (strncmp(be, "From ", 5) == 0) {

	    hepigs = ftell(stdin);
	    if (hepigs == -1) {perror("Noooo! ftell failed!");
	        exit(56);}
	    if (!(fgets(good, 1024, stdin)))
		break;
	    if (strncmp(good, "From: ", 6) == 0) {
		if (strncmp(be + 5, good + 6, l - 5) == 0) {
		    if (strstr(good, "postoffice@juno.com")) {
			o_go = o_lose;
			header = 1;
		    } else {
			for (;;) {
			    if (!(fgets(good, 1024, stdin)))
				break;
			    if (strlen(good) < 3)
				break;
			    if (strncmp(good, "Date: ", 6))
				continue;
			    bee = good + 6;
			    if ((o_go = parsedate(bee, NULL)) == -1)
				o_go = o_lose;
			    header = 1;
			    break;
			}
		    }
		    l = mutt(l, be);
		    sea = be + l - 1;
		    if (splat == NULL) {
			o_go = o_lose;
			header = 1;
		    }
		    if (header) {
			m = sprintf(sea + 1, " %24s", ctime(&o_go));
			strcpy(sea + m, "");
			l += m;
		    }
		} else {
		    rabid = strlen(good);
		    if ((rabid > 10) && (l - rabid > 16)) {
			header = 1;
			/*     if(strncmp(be+5, good+6, rabid -8) == 0) goto flush; */
			/* looks like spam from Micro$oft Ouchlook Distress */
			/* let procmail or pine try to deal with it */
		    }
		}
	    }
	  flush:
	    fold = 0;
	    fseek(stdin, hepigs, SEEK_SET);
	    if (header) {
		if (proc) {
		    if (splat)
			pclose(splat);
		    splat = popen(procm, "w");
		} else
		    splat = stdout;
	    }
	}
	if (l == 0)
	    fold = 1;
	be[l] = 0;
	if (spam) {
	    fprintf(stderr, "%s\n", be);
	    continue;
	}
	if ((fold) && (FOLD)) {
	    brk = be;
	    while ((be + l) > (brk + FOLD)) {
		nb = brk + FOLD;
		was = *nb;
		*nb = 0;
		nb = rindex(brk, 32);
		if (nb)
		    *nb = 10;
		else
		    nb = brk + FOLD;
		brk += FOLD;
		*brk = was;
		brk = nb;
	    }
	}
	if (splat == NULL) {
	    fprintf(stderr, "OOPS, this is not a mail file, I think!\n");
	    exit(57);
	}
	fprintf(splat, "%s\n", be);
    }
    if ((proc) && (splat))
	pclose(splat);
    return 0;
}
